<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:seaf="http://seaf.sf.net/seaf"
	xmlns:per="http://seaf.sf.net/seaf-persistence"
	version="2.0">
<import href="functions/SeafPersistenceBusinessFunctions.xsl" />
<output method="text" />

<template match="//per:persistence/per:entity">
	<variable name="entity-class" select="@name" />
	<variable name="entity-full-type" select="per:entity-full-type(.)" />
	<variable name="criteria-full-type" select="per:entity-criteria-full-type(.)" />
	<variable name="criteria-class" select="seaf:type-class($criteria-full-type)" />
	<variable name="full-type" select="per:controller-base-full-type(.)" />
	<variable name="class" select="seaf:type-class($full-type)" />
	<variable name="dir" select="seaf:type-dir($full-type)" />
	<variable name="package" select="seaf:type-package($full-type)" />
	<variable name="type-label" select="per:persistent-object-type-label(.)" />
	<variable name="pk-type" select="per:persitent-object-pk-type(.)" />

<result-document href="{$dir}/{$class}.java">

<text />/**
 * GENERATED BY Seaf Persistence Generator. DO NOT EDIT.
 */
package <value-of select="$package" />;

import java.util.List;

import net.sf.seaf.persistence.ServerController;
import net.sf.seaf.common.Page;

import <value-of select="$entity-full-type" />;
import <value-of select="$criteria-full-type" />;

/**
 * The <value-of select="$entity-class" /> server controller base interface.
 * Defines common controller methods for the <text />
 	<value-of select="$entity-class" /><text> </text>
 	<value-of select="$type-label" />.
 */
public interface <value-of select="$class" /> extends ServerController {

	/**
	 * Create an instance of the <value-of select="$entity-class" /><text> </text>
	 	<value-of select="$type-label" />.
	 * 
	 * @param e
	 *            <value-of select="$entity-class" /> instance
	 * @return <value-of select="$entity-class" /> The created <text />
	 	<value-of select="$type-label" /> instance
	 */
	<value-of select="$entity-class" /> create(<value-of select="$entity-class" /> e);

	/**
	 * Retrieve an instance of the <value-of select="$entity-class" /><text> </text>
	 	<value-of select="$type-label" />.
	 * 
	 * @param id
	 *            The value of the primary key
	 * @return <value-of select="$entity-class" /> The retrieved <text />
	 	<value-of select="$type-label" /> instance
	 */
	<value-of select="$entity-class" /> retrieve(<value-of select="$pk-type" /> id);

	/**
	 * Refresh an instance of the <text />
	 	<value-of select="$entity-class" /><text> </text>
	 		<value-of select="$type-label" /> from the database.
	 * 
	 * @param e
	 *            <value-of select="$entity-class" /> instance
	 * @return <value-of select="$entity-class" /> The refreshed <text />
	 	<value-of select="$type-label" /> instance
	 */
	<value-of select="$entity-class" /> refresh(<text />
		<value-of select="$entity-class" /> e);<text />

<if test="@code-table">

	/**
	 * Refresh an instance of the <text />
	 	<value-of select="$entity-class" /><text> </text>
	 		<value-of select="$type-label" /> from the database,
	 * based on the code of the code table.
	 * 
	 * @param e
	 *            <value-of select="$entity-class" /> instance with code set
	 * @return <value-of select="$entity-class" /> The refreshed <text />
	 	<value-of select="$type-label" /> instance
	 */
	<value-of select="$entity-class" /> refreshByCode(<text />
		<value-of select="$entity-class" /> e);<text />
</if>

<if test="@code-table='time-bound'">

	/**
	 * Apply time-bound criteria to the given criteria instance, ensuring that
	 * only currently valid code table records are found.
	 * 
	 * @param criteria
	 *            <value-of select="$entity-class" /> criteria
	 */
	public void applyTimeBoundCriteria(<value-of select="$criteria-class" /> criteria);<text />
</if>

	/**
	 * Update an instance of the <value-of select="$entity-class" /><text> </text>
	 	<value-of select="$type-label" />.
	 * 
	 * @param e
	 *            <value-of select="$entity-class" /> instance
	 */
	void update(<value-of select="$entity-class" /> e);

	/**
	 * Delete an instance of the <value-of select="$entity-class" /><text> </text>
	 	<value-of select="$type-label" />.
	 * 
	 * @param e
	 *            <value-of select="$entity-class" /> instance
	 */
	void delete(<value-of select="$entity-class" /> e);

	/**
	 * Find instances of the <text />
	 	<value-of select="$entity-class" /><text> </text>
	 		<value-of select="$type-label" /> based on its criteria.
	 * 
	 * @param criteria
	 *            <value-of select="$entity-class" /> criteria
	 * @return List&amp;lt;<value-of select="$entity-class" />
	 	<text />> List of <value-of select="$type-label" />
	 	<text /> instances matching the criteria
	 */
	List&lt;<value-of select="$entity-class" />> find(<text />
		<value-of select="$criteria-class" /> criteria);

	/**
	 * Find instances of the <value-of select="$entity-class" /><text> </text>
	 	<value-of select="$type-label" /> based on its criteria and
	 * return a specified page (subset) of the matching records.
	 * 
	 * @param criteria
	 *            <value-of select="$entity-class" /> criteria
	 * @param page
	 *            The page (subset) of records to return
	 * @return List&amp;lt;<value-of select="$entity-class" />
	 	<text />> List of <value-of select="$type-label" />
	 	<text /> instances matching the criteria
	 */
	List&lt;<value-of select="$entity-class" />> findPage(<text />
		<value-of select="$criteria-class" /> criteria, Page page);

	/**
	 * Return the number of instances of the <text />
	 	<value-of select="$entity-class" /><text> </text>
	 	<value-of select="$type-label" /> matching its criteria.
	 * 
	 * @param criteria
	 *            <value-of select="$entity-class" /> criteria
	 * @return int The number of matching instances
	 */
	int size(<value-of select="$criteria-class" /> criteria);<text />

<if test="@code-table">

	/**
	 * Find all valid instances of the <value-of select="$entity-class" />
	 	<text /> code table.
	 * 
	 * @return List&amp;lt;<value-of select="$entity-class" />
	 	<text />> List of all valid code table instances
	 */
	List&lt;<value-of select="$entity-class" />> findAllValid();<text />
</if>

}
<text />

</result-document>
</template>

</stylesheet>
